config/routes.rb
Rails.application.routes.draw do
  root 'login#index'

  resources :login, only: [:index, :new]
  resources :users, only: [:new, :create]
  scope module: :admin do
    resources :addresses, only: [:index]
    resources :users, only: [:update]
    resources :registers, only: [:new, :create]
    resources :bills, only: [:new, :create]
    resources :prices, only: [:new, :create]
  end
  scope module: :logged do
    resources :readings, only: [:new, :create]
    resources :users, only: [:show] do
      get 'search', on: :collection
    end
  end
end

app/models/user.rb
class User < ApplicationRecord
  has_many :bills
  belongs_to :address
  accepts_nested_attributes_for :address
  validates :username, presence: true, uniqueness: true

  def kwh_billed_till(date)
    bills.active.billed_till(date).sum(&:kwh_billed)
  end

  def kwh_to_be_billed_till(date)
    address.kwh_used_till(date) - kwh_billed_till(date)
  end

  def bill_amount_by_date(date)
    BigDecimal(Price.price_by_date(date) * kwh_to_be_billed_till(date), 2)
  end
end

app/controllers/admin/users_controller.rb
module Admin
  class UsersController < AdminBaseController
    def update
      @user = User.find(params[:user][:id])
      @user.status = params[:user][:status]

      @user.save
      redirect_to addresses_url
    end
  end
end

app/controllers/logged/users_controller.rb
module Logged
  class UsersController < SessionBaseController
    def show
      @user = User.find(params[:id])
    end

    def search
      @user = User.find_by(username: params[:username])

      if @user.nil?
        flash[:notice] = "User #{params[:username]} not found"
        redirect_to root_url
      else
        redirect_to @user
      end
    end
  end
end

app/controllers/users_controller.rb
class UsersController < UsersBaseController
  def new
    @user = User.new

    @user.build_address
  end

  def create
    @user = User.new(user_params)

    if @user.save
      start_session
      redirect_to @user
    else
      render 'new'
    end
  end

  private

  def user_params
    params.require(:user).permit(:username, :status, address_attributes: [:number, :street, :town_suburb, :region_city, :postcode, :icp])
  end
end

app/views/users/new.html.erb
<h1>Create User</h1>

<%= form_with model: @user, url: users_path, local: true do |user_form| %>
    
    <%= render 'components/errors', object: @user %>
    
    <p>
	<%= user_form.label :username %><br>
	<%= user_form.text_field :username %>
    </p>
    
    <strong>Address</strong>
    <%= user_form.fields_for :address do |address_form| %>
	
	<p>
	    <%= address_form.label :number %><br>
	    <%= address_form.text_field :number %>
	</p>
	<p>
	    <%= address_form.label :street %><br>
	    <%= address_form.text_field :street %>
	</p>
	<p>
	    <%= address_form.label :town_suburb, 'Town or Suburb'%><br>
	    <%= address_form.text_field :town_suburb %>
	</p>
	<p>
	    <%= address_form.label :region_city, 'Region or City' %><br>
	    <%= address_form.text_field :region_city %>
	</p>
	<p>
	    <%= address_form.label :postcode %><br>
	    <%= address_form.text_field :postcode %>
	</p>
	<p>
	    <%= address_form.label :icp, 'ICP' %><br>
	    <%= address_form.text_field :icp %>
	</p>
    <% end %>
    
    <p>
	<%= user_form.submit %>
    </p>
<% end %>
<br>
<%= link_to 'Cancel', root_path %>